%VARIABLES
t=0.55;      %espai intersticial
alfai=0;     %angle inicial
alfac=90;    %angle entre capes
h=0.29;      %alada capa
zi=0.175;    %alada inicial
xi=20;       %posicio x inicial
yi=20;       %posicio y inicial
e=2;         %velocitat extrusor
l=0.05;      %quantitat de material longitudinalment linies rectes
d=0.030;     %quantitat de material en espais curts linies rectes
ll=0.055;    %quantitat de material longitudinalment linies inclinades
dd=0.035;    %quantitat de material en espais curts linies inclinades
s=10;        %velocitat desplaament linies rectes
s1=4;        %velocitat desplaament linies inclinades
s2=4;        %veolicatat desplaament transici
f=60*s;      %convercions extrusor
f1=60*s1;
f2=60*s2;
xt=20;       %dimensio x desitjada
yt=20;       %dimensio y desitjada
zt=10;       %dimensio z desitjada
r=1.2;       %retroces extrusor
lin_ini=1.3; %valor inicial extrusor
m=t*2*cos(45)%distancia per a linies inclinades
q=m
w=(round(xt/m))
n_punts=w*4 %nombre de punts que formen una capa
c=0         %variable de control de la capa actual
alfaa=alfai %variable de control de l'angle actual
val_z=zi+(c*h)
extr=0



fid = fopen('tots2.txt', 'w'); %obrir un fitxer
%inicialitzacio
 xt=m*w
 yt=m*w
fprintf(fid,'G90\n');
fprintf(fid,'G21\n');
fprintf(fid,'G92 E0\n');
fprintf(fid,';S%4.2f\n',s);

fprintf(fid,'G%4.2f X%4.2f Y%4.2f Z%4.3f F%4.2f\n',1,xi,yi,zi,f);
fprintf(fid,'F%4.2f\n',f);
fprintf(fid,'G%4.2f E%4.2f\n',1,0);
fprintf(fid,'G%4.2f F%4.2f\n',1,f);
fprintf(fid,'G%4.2f E%4.2f\n',92,0);

%recorregut inicial_test
fprintf(fid,'G%4.2f X%4.2f Y%4.2f Z%4.3f F%4.2f E%4.2f\n',1,5,yi-5,zi,f,0.0002);
fprintf(fid,'G%4.2f X%4.2f Y%4.2f Z%4.3f F%4.2f E%4.2f\n',1,5,yi+35,zi,f,40*l);
fprintf(fid,'G%4.2f X%4.2f Y%4.2f Z%4.3f F%4.2f E%4.2f\n',1,6,yi+35,zi,f,40*l+1*d);
fprintf(fid,'G%4.2f X%4.2f Y%4.2f Z%4.3f F%4.2f E%4.2f\n',1,6,yi-5,zi,f,40*l+1*d+40*l);
fprintf(fid,'G%4.2f X%4.2f Y%4.2f Z%4.3f F%4.2f E%4.2f\n',1,7,yi-5,zi,f,40*l+1*d+40*l+1*l);
fprintf(fid,'G%4.2f X%4.2f Y%4.2f Z%4.3f F%4.2f E%4.2f\n',1,7,yi+35,zi,f,40*l+1*d+40*l+1*l+40*l);
fprintf(fid,'G%4.2f X%4.2f Y%4.2f Z%4.3f F%4.2f E%4.2f\n',1,8,yi+35,zi,f,40*l+1*d+40*l+1*l+40*l+1*l);
fprintf(fid,'G%4.2f X%4.2f Y%4.2f Z%4.3f F%4.2f E%4.2f\n',1,8,yi-5,zi,f,40*l+1*d+40*l+1*l+40*l+1*l+40*l);
fprintf(fid,'G%4.2f F%4.2f\n',1,f);
fprintf(fid,'G%4.2f E%4.2f\n',92,0);

% cas d'inici 0 i angle de variaci 90
while  val_z<=zt
if alfaa==0|mod(alfaa,180)==0  %MULTIPLES
val_x=[xi:t:(xi+xt)] %valors de x
vect_x=[val_x;val_x]
vect_x=reshape(vect_x,[],1) 
val_y=[yi yi+yt yi+yt yi]
vect_y=repmat(val_y,(size(vect_x/2)))
vect_y=reshape(vect_y',[],1)
vect_y=vect_y(1:(size(vect_x)))
vect_z=repmat(val_z,(size(vect_x)))
vect_f=repmat(f,(size(vect_x)))
val_e=[sqrt(((vect_x(2)-(vect_x(3))))^2+((vect_y(2)-(vect_y(3))))^2);sqrt(((vect_x(1)-(vect_x(2))))^2+((vect_y(1)-(vect_y(2))))^2) ];
vect_e=repmat(val_e,(size(((vect_x)-1)/2)))
extr=sum(vect_e(1:(numel(vect_x))))+extr
vect_e(1)=lin_ini
for ii=2:size(vect_x)
   if vect_e(ii)>2
        vect_e(ii)=vect_e(ii-1)+vect_e(ii)*l
    else
        vect_e(ii)=vect_e(ii-1)+vect_e(ii)*d
   end 
end
vect_f(ii)=f1


%imprimir
for ii=1:size(vect_x)
fprintf(fid,'G%4.2f X%4.2f  Y%4.2f  Z%4.3f F%4.2f  E%4.4f\n',1,vect_x(ii),vect_y(ii),vect_z(ii),vect_f(ii),vect_e(ii))
end
fprintf(fid,'G%4.2f F%4.2f\n',1,f);
fprintf(fid,'G%4.2f E%4.2f\n',1,(vect_e(ii)-r));
fprintf(fid,'G%4.2f F%4.2f\n',1,f);
% %Peparacio capa seguent
c=c+1
val_z=zi+(c*h)
alfaa=alfaa+alfac

if vect_x(ii)==yi+yt
    fprintf(fid,'G%4.2f X%4.2f  Y%4.2f  Z%4.3f F%4.2f\n',1,xi,yi+yt,val_z,f2)
else
    fprintf(fid,'G%4.2f X%4.2f  Y%4.2f  Z%4.3f F%4.2f\n',1,xi+xt,yi+yt,val_z,f2)
    fprintf(fid,'G%4.2f  X%4.2f  Y%4.2f  Z%4.3f F%4.2f\n',1,xi,yi+yt,val_z,f2)
end
fprintf(fid,'G%4.2f F%4.2f\n',1,f);
fprintf(fid,'G%4.2f E%4.2f\n',92,0);





elseif alfaa==90|mod((alfaa-90),180)==0 %MULTIPLES
val_y=[(yi+yt):-t:yi] 
vect_y=[val_y;val_y]
vect_y=reshape(vect_y,[],1) 
val_x=[xi xi+xt xi+xt xi]
vect_x=repmat(val_x,(size(vect_y/2)))
vect_x=reshape(vect_x',[],1)
vect_x=vect_x(1:size(vect_y))
vect_z=repmat(val_z,(size(vect_y)))
vect_f=repmat(f,(size(vect_x)))
val_e=[sqrt(((vect_x(2)-(vect_x(3))))^2+((vect_y(2)-(vect_y(3))))^2);sqrt(((vect_x(1)-(vect_x(2))))^2+((vect_y(1)-(vect_y(2))))^2)];
vect_e=repmat(val_e,(size(((vect_x)-1)/2)))
extr=sum(vect_e(1:(numel(vect_x))))+extr
vect_e(1)=lin_ini
for ii=2:size(vect_x)
   if vect_e(ii)>2
        vect_e(ii)=vect_e(ii-1)+vect_e(ii)*l
    else
        vect_e(ii)=vect_e(ii-1)+vect_e(ii)*d
    end
end
vect_f(ii)=f1

% %imprimir
for ii=1:size(vect_x)
fprintf(fid,'G%4.2f X%4.2f  Y%4.2f  Z%4.3f F%4.2f  E%4.4f\n',1,vect_x(ii),vect_y(ii),vect_z(ii),vect_f(ii),vect_e(ii))
end
fprintf(fid,'G%4.2f F%4.2f\n',1,f);
fprintf(fid,'G%4.2f E%4.2f\n',1,(vect_e(ii)-r));
fprintf(fid,'G%4.2f F%4.2f\n',1,f);
% %Peparacio capa seguent
c=c+1
val_z=zi+(c*h)
alfaa=alfaa+alfac

if vect_x(ii)==xi+xt
    fprintf(fid,'G%4.2f X%4.2f  Y%4.2f  Z%4.3f F%4.2f\n',1,xi,yi,val_z,f2)
else
    fprintf(fid,'G%4.2f X%4.2f  Y%4.2f  Z%4.3f F%4.2f\n',1,xi,yi,val_z,f2)
end
fprintf(fid,'G%4.2f F%4.2f\n',1,f2);
fprintf(fid,'G%4.2f E%4.2f\n',92,0);



elseif alfaa==45|mod(alfaa-45,180)==0  %MULTIPLES
val_x1=repmat(xi,1,n_punts/2) %valors de x
val_x2=repmat(xi+xt,1,n_punts/2)
vect_x=[val_x1 val_x2]
val_y1=repmat(yi,1,n_punts/2) %valors de x
val_y2=repmat(yi+yt,1,n_punts/2)
vect_y= [val_y1 val_y2]
vect_e(1)=lin_ini
  if mod(w,2)==0
      for ii=2:4:((n_punts)/2)
          vect_x(ii)=vect_x(ii)+q 
          q=q+m
           if ii<(n_punts/2)-3
          vect_x(ii+3)=vect_x(ii+3)+q
          q=q+m
           end
      end
     q=q-m
      for ii=((n_punts/2)+1):4:n_punts
          vect_x(ii+2)=vect_x(ii+2)-q 
          q=q-m
          if ii<n_punts-2
          vect_x(ii+3)=vect_x(ii+3)-q
          q=q-m
          end
      end
       q=m
       
 
       for ii=1:4:((n_punts)/2)-1
          vect_y(ii+2)=vect_y(ii+2)+q 
          q=q+m
          if ii<n_punts-2
          vect_y(ii+3)=vect_y(ii+3)+q
          q=q+m
          end
      end
      q=q-m
              for ii=((n_punts/2)+1):4:n_punts
          vect_y(ii)=vect_y(ii)-q 
          q=q-m
           if ii<(n_punts)-2
          vect_y(ii+1)=vect_y(ii+1)-q
          q=q-m
           end
      end
     q=m
  else
         for ii=2:4:((n_punts)/2)
          vect_x(ii)=vect_x(ii)+q
          q=q+m
           if ii<(n_punts/2)-3
          vect_x(ii+3)=vect_x(ii+3)+q
          q=q+m
           end
      end
     q=q-m
      for ii=((n_punts/2)+1):4:n_punts
          vect_x(ii)=vect_x(ii)-q 
          q=q-m
          if ii<n_punts-2
          vect_x(ii+1)=vect_x(ii+1)-q
          q=q-m
          end
      end
       q=m
       

       for ii=1:4:((n_punts)/2)-1
           if ii<(n_punts/2)-3
           vect_y(ii+2)=vect_y(ii+2)+q 
          q=q+m
          vect_y(ii+3)=vect_y(ii+3)+q
          q=q+m
          end
      end
      q=q-m
          for ii=((n_punts/2)+1):4:n_punts
          if ii<=(n_punts)-2
          vect_y(ii+2)=vect_y(ii+2)-q 
          q=q-m
          vect_y(ii+3)=vect_y(ii+3)-q
          q=q-m
           end
      end
     q=m
  end


vect_z=repmat(val_z,(size(vect_x)))
vect_f=repmat(f1,(size(vect_x)))
vect_e=repmat(1,(size(vect_x))) 

vect_e(1)=lin_ini    
for ii=2:numel(vect_x)
     vect_e(ii)= (sqrt(((vect_x(ii-1)-(vect_x(ii))))^2+((vect_y(ii-1)-(vect_y(ii))))^2))
     extr=vect_e(ii)+extr
     if vect_e(ii)>2
        vect_e(ii)=vect_e(ii-1)+vect_e(ii)*ll
    else
        vect_e(ii)=vect_e(ii-1)+vect_e(ii)*dd
    end
end

%imprimir
for ii=1:numel(vect_x)
fprintf(fid,'G%4.2f X%4.2f  Y%4.2f  Z%4.3f F%4.2f  E%4.4f\n',1,vect_x(ii),vect_y(ii),vect_z(ii),vect_f(ii),vect_e(ii))
end
fprintf(fid,'G%4.2f F%4.2f\n',1,f);
fprintf(fid,'G%4.2f E%4.2f\n',1,(vect_e(ii)-r));
fprintf(fid,'G%4.2f F%4.2f\n',1,f);
% %Peparacio capa seguent
c=c+1
val_z=zi+(c*h)
alfaa=alfaa+alfac

if vect_x(ii)==yi+yt
    fprintf(fid,'G%4.2f X%4.2f  Y%4.2f  Z%4.3f F%4.2f\n',1,xi,yi+yt,val_z,f2)
else
    fprintf(fid,'G%4.2f X%4.2f  Y%4.2f  Z%4.3f F%4.2f\n',1,xi+xt,yi+yt,val_z,f2)
    fprintf(fid,'G%4.2f  X%4.2f  Y%4.2f  Z%4.3f F%4.2f\n',1,xi,yi+yt,val_z,f)
end
fprintf(fid,'G%4.2f F%4.2f\n',1,f);
fprintf(fid,'G%4.2f E%4.2f\n',92,0);


elseif alfaa==135|mod(alfaa-135,180)==0  %MULTIPLES
val_x1=repmat(xi,1,n_punts/2) %valors de x
val_x2=repmat(xi+xt,1,n_punts/2)
vect_x= [val_x1 val_x2]
val_y1=repmat(yi,1,n_punts/2) %valors de x
val_y2=repmat(yi+yt,1,n_punts/2)
vect_y= [val_y2 val_y1]
  if mod(w,2)==0
      for ii=2:4:((n_punts)/2)
          vect_x(ii)=vect_x(ii)+q 
          q=q+m
           if ii<(n_punts/2)-3
          vect_x(ii+3)=vect_x(ii+3)+q
          q=q+m
           end
      end
     q=q-m
      for ii=((n_punts/2)+1):4:n_punts
          vect_x(ii+2)=vect_x(ii+2)-q 
          q=q-m
          if ii<n_punts-2
          vect_x(ii+3)=vect_x(ii+3)-q
          q=q-m
          end
      end
       q=m
       
 for ii=1:4:((n_punts)/2)
          vect_y(ii+2)=vect_y(ii)-q 
          q=q+m
           if ii<(n_punts)-2
          vect_y(ii+3)=vect_y(ii+1)-q
          q=q+m
           end
      end
       
      q=q-m
       for ii=((n_punts/2)+1):4:n_punts
          vect_y(ii)=vect_y(ii)+q 
          q=q-m
          if ii<n_punts-1
          vect_y(ii+1)=vect_y(ii+1)+q
          q=q-m
          end
      end   
     q=m
  else
         for ii=2:4:((n_punts)/2)
          vect_x(ii)=vect_x(ii)+q
          q=q+m
           if ii<(n_punts/2)-3
          vect_x(ii+3)=vect_x(ii+3)+q
          q=q+m
           end
      end
     q=q-m
      for ii=((n_punts/2)+1):4:n_punts
          vect_x(ii)=vect_x(ii)-q 
          q=q-m
          if ii<n_punts-2
          vect_x(ii+1)=vect_x(ii+1)-q
          q=q-m
          end
      end
       q=m
       

       for ii=1:4:((n_punts)/2)-1
           if ii<(n_punts/2)-3
           vect_y(ii+2)=vect_y(ii+2)-q 
          q=q+m
          vect_y(ii+3)=vect_y(ii+3)-q
          q=q+m
          end
      end
      q=q-m
          for ii=((n_punts/2)+1):4:n_punts
          if ii<=(n_punts)-2
          vect_y(ii+2)=vect_y(ii+2)+q 
          q=q-m
          vect_y(ii+3)=vect_y(ii+3)+q
          q=q-m
           end
      end
     q=m
  end


vect_z=repmat(val_z,(size(vect_x)))
vect_f=repmat(f1,(size(vect_x)))
vect_e=repmat(1,(size(vect_x)))  

vect_e(1)=lin_ini    
for ii=2:numel(vect_x)
    vect_e(ii)= (sqrt(((vect_x(ii-1)-(vect_x(ii))))^2+((vect_y(ii-1)-(vect_y(ii))))^2))
    extr=vect_e(ii)+extr
    if vect_e(ii)>2
        vect_e(ii)=vect_e(ii-1)+vect_e(ii)*ll
    else
        vect_e(ii)=vect_e(ii-1)+vect_e(ii)*dd
    end
end

% %imprimir
for ii=1:numel(vect_x)
fprintf(fid,'G%4.2f X%4.2f  Y%4.2f  Z%4.3f F%4.2f  E%4.4f\n',1,vect_x(ii),vect_y(ii),vect_z(ii),vect_f(ii),vect_e(ii))
end
fprintf(fid,'G%4.2f F%4.2f\n',1,f);
mat=extr*pi()*0.175*0.175 %quantitat de material en cm^3 DENSITAT PLA 1.24g/cm^3
pes=mat*1.24/1000

fprintf(fid,'G%4.2f E%4.2f\n',1,(vect_e(ii)-r));
fprintf(fid,'G%4.2f F%4.2f\n',1,f);
% %Peparacio capa seguent
c=c+1
val_z=zi+(c*h)
alfaa=alfaa+alfac

if vect_x(ii)==yi+yt
    fprintf(fid,'G%4.2f X%4.2f  Y%4.2f  Z%4.3f F%4.2f\n',1,xi,yi+yt,val_z,f2)
else
    fprintf(fid,'G%4.2f X%4.2f  Y%4.2f  Z%4.3f F%4.2f\n',1,xi+xt,yi+yt,val_z,f2)
    fprintf(fid,'G%4.2f  X%4.2f  Y%4.2f  Z%4.3f F%4.2f\n',1,xi,yi+yt,val_z,f)
end
fprintf(fid,'G%4.2f F%4.2f\n',1,f);
fprintf(fid,'G%4.2f E%4.2f\n',92,0);
end
end
pes=extr*pi()*(0.35/2)^2*0.00124
fclose(fid);